[@rxap/forms](../wiki/globals) / RxapFormGroup

# Class: RxapFormGroup\<T, E\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:49](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L49)

## Extends

- `UntypedFormGroup`

## Type Parameters

• **T** = `any`

• **E** *extends* [`ValidationErrors`](../wiki/TypeAlias.ValidationErrors) = `any`

## Constructors

### new RxapFormGroup()

> **new RxapFormGroup**\<`T`, `E`\>(`controls`, `options`): [`RxapFormGroup`](../wiki/Class.RxapFormGroup)\<`T`, `E`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:129](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L129)

#### Parameters

##### controls

[`ExtractAbstractControl`](../wiki/TypeAlias.ExtractAbstractControl)\<[`KeyValueControls`](../wiki/TypeAlias.KeyValueControls)\<`T`\>, `T`\>

##### options

[`FormGroupOptions`](../wiki/Interface.FormGroupOptions)

#### Returns

[`RxapFormGroup`](../wiki/Class.RxapFormGroup)\<`T`, `E`\>

#### Overrides

`UntypedFormGroup.constructor`

## Properties

### controlId

> `readonly` **controlId**: `string`

Defined in: [packages/angular/forms/src/lib/form-group.ts:103](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L103)

***

### controls

> **controls**: [`ExtractAbstractControl`](../wiki/TypeAlias.ExtractAbstractControl)\<[`KeyValueControls`](../wiki/TypeAlias.KeyValueControls)\<`T`\>, `T`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:130](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L130)

#### Inherited from

`UntypedFormGroup.controls`

***

### dirty$

> **dirty$**: `Observable`\<`boolean`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:95](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L95)

***

### disabled$

> `readonly` **disabled$**: `Observable`\<`boolean`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:98](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L98)

***

### enabled$

> `readonly` **enabled$**: `Observable`\<`boolean`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:99](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L99)

***

### errors

> `readonly` **errors**: `null` \| `E`

Defined in: [packages/angular/forms/src/lib/form-group.ts:85](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L85)

An object containing any errors generated by failing validation,
or null if there are no errors.

#### Overrides

`UntypedFormGroup.errors`

***

### errors$

> `readonly` **errors$**: `Observable`\<`null` \| `E`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:101](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L101)

***

### events

> `readonly` **events**: `Observable`\<`ControlEvent`\<`any`\>\>

Defined in: node\_modules/@angular/forms/index.d.ts:2278

A multicasting observable that emits an event every time the state of the control changes.
It emits for value, status, pristine or touched changes.

**Note**: On value change, the emit happens right after a value of this control is updated. The
value of a parent control (for example if this FormControl is a part of a FormGroup) is updated
later, so accessing a value of a parent control (using the `value` property) from the callback
of this event might result in getting a value that has not been updated yet. Subscribe to the
`events` of the parent control instead.
For other event types, the events are emitted after the parent control has been updated.

#### Inherited from

`UntypedFormGroup.events`

***

### status

> `readonly` **status**: [`ControlState`](../wiki/TypeAlias.ControlState)

Defined in: [packages/angular/forms/src/lib/form-group.ts:88](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L88)

The validation status of the control.

#### See

FormControlStatus

These status values are mutually exclusive, so a control cannot be
both valid AND invalid or invalid AND disabled.

#### Overrides

`UntypedFormGroup.status`

***

### status$

> `readonly` **status$**: `Observable`\<[`ControlState`](../wiki/TypeAlias.ControlState)\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:100](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L100)

***

### statusChanges

> `readonly` **statusChanges**: `Observable`\<[`ControlState`](../wiki/TypeAlias.ControlState)\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:89](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L89)

A multicasting observable that emits an event every time the validation `status` of the control
recalculates.

#### See

 - FormControlStatus
 - [AbstractControl.status](../wiki/Interface.AbstractControl#status)

#### Overrides

`UntypedFormGroup.statusChanges`

***

### touch$

> **touch$**: `Observable`\<`boolean`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:94](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L94)

***

### value

> `readonly` **value**: `T`

Defined in: [packages/angular/forms/src/lib/form-group.ts:84](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L84)

The current value of the control.

* For a `FormControl`, the current value.
* For an enabled `FormGroup`, the values of enabled controls as an object
with a key-value pair for each member of the group.
* For a disabled `FormGroup`, the values of all controls as an object
with a key-value pair for each member of the group.
* For a `FormArray`, the values of enabled controls as an array.

#### Overrides

`UntypedFormGroup.value`

***

### value$

> `readonly` **value$**: `Observable`\<`T`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:97](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L97)

***

### valueChanges

> `readonly` **valueChanges**: `Observable`\<`T`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:86](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L86)

A multicasting observable that emits an event every time the value of the control changes, in
the UI or programmatically. It also emits an event each time you call enable() or disable()
without passing along {emitEvent: false} as a function argument.

**Note**: the emit happens right after a value of this control is updated. The value of a
parent control (for example if this FormControl is a part of a FormGroup) is updated later, so
accessing a value of a parent control (using the `value` property) from the callback of this
event might result in getting a value that has not been updated yet. Subscribe to the
`valueChanges` event of the parent control instead.

#### Overrides

`UntypedFormGroup.valueChanges`

## Accessors

### asyncValidator

#### Get Signature

> **get** **asyncValidator**(): `null` \| `AsyncValidatorFn`

Defined in: node\_modules/@angular/forms/index.d.ts:2161

Returns the function that is used to determine the validity of this control asynchronously.
If multiple validators have been added, this will be a single composed function.
See `Validators.compose()` for additional information.

##### Returns

`null` \| `AsyncValidatorFn`

#### Set Signature

> **set** **asyncValidator**(`asyncValidatorFn`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2162

##### Parameters

###### asyncValidatorFn

`null` | `AsyncValidatorFn`

##### Returns

`void`

#### Inherited from

`UntypedFormGroup.asyncValidator`

***

### controlPath

#### Get Signature

> **get** **controlPath**(): `string`

Defined in: [packages/angular/forms/src/lib/form-group.ts:105](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L105)

##### Returns

`string`

***

### dirty

#### Get Signature

> **get** **dirty**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2249

A control is `dirty` if the user has changed the value
in the UI.

##### Returns

`boolean`

True if the user has changed the value of this control in the UI; compare `pristine`.
Programmatic changes to a control's value do not mark it dirty.

#### Inherited from

`UntypedFormGroup.dirty`

***

### disabled

#### Get Signature

> **get** **disabled**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2216

A control is `disabled` when its `status` is `DISABLED`.

Disabled controls are exempt from validation checks and
are not included in the aggregate value of their ancestor
controls.

##### See

[AbstractControl.status](../wiki/Interface.AbstractControl#status)

##### Returns

`boolean`

True if the control is disabled, false otherwise.

#### Inherited from

`UntypedFormGroup.disabled`

***

### enabled

#### Get Signature

> **get** **enabled**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2226

A control is `enabled` as long as its `status` is not `DISABLED`.

##### See

[AbstractControl.status](../wiki/Interface.AbstractControl#status)

##### Returns

`boolean`

True if the control has any status other than 'DISABLED',
false if the status is 'DISABLED'.

#### Inherited from

`UntypedFormGroup.enabled`

***

### fullControlPath

#### Get Signature

> **get** **fullControlPath**(): `string`

Defined in: [packages/angular/forms/src/lib/form-group.ts:119](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L119)

##### Returns

`string`

***

### invalid

#### Get Signature

> **get** **invalid**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2195

A control is `invalid` when its `status` is `INVALID`.

##### See

[AbstractControl.status](../wiki/Interface.AbstractControl#status)

##### Returns

`boolean`

True if this control has failed one or more of its validation checks,
false otherwise.

#### Inherited from

`UntypedFormGroup.invalid`

***

### parent

#### Get Signature

> **get** **parent**(): `null` \| `FormGroup`\<`any`\> \| `FormArray`\<`any`\>

Defined in: node\_modules/@angular/forms/index.d.ts:2166

The parent control.

##### Returns

`null` \| `FormGroup`\<`any`\> \| `FormArray`\<`any`\>

#### Inherited from

`UntypedFormGroup.parent`

***

### pending

#### Get Signature

> **get** **pending**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2204

A control is `pending` when its `status` is `PENDING`.

##### See

[AbstractControl.status](../wiki/Interface.AbstractControl#status)

##### Returns

`boolean`

True if this control is in the process of conducting a validation check,
false otherwise.

#### Inherited from

`UntypedFormGroup.pending`

***

### pristine

#### Get Signature

> **get** **pristine**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2239

A control is `pristine` if the user has not yet changed
the value in the UI.

##### Returns

`boolean`

True if the user has not yet changed the value in the UI; compare `dirty`.
Programmatic changes to a control's value do not mark it dirty.

#### Set Signature

> **set** **pristine**(`value`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2240

##### Parameters

###### value

`boolean`

##### Returns

`void`

#### Inherited from

`UntypedFormGroup.pristine`

***

### readonly

#### Get Signature

> **get** **readonly**(): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:70](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L70)

##### Returns

`boolean`

#### Set Signature

> **set** **readonly**(`value`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:74](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L74)

##### Parameters

###### value

`boolean`

##### Returns

`void`

***

### root

#### Get Signature

> **get** **root**(): `AbstractControl`

Defined in: node\_modules/@angular/forms/index.d.ts:2758

Retrieves the top-level ancestor of this control.

##### Returns

`AbstractControl`

#### Inherited from

`UntypedFormGroup.root`

***

### rxapFormDefinition

#### Get Signature

> **get** **rxapFormDefinition**(): `undefined` \| `Partial`\<[`FormDefinition`](../wiki/Interface.FormDefinition)\<`T`, `any`, `any`\>\> & \{ \[K in string \| number \| symbol\]: T\[K\] extends U\[\] ? FormDefinitionArray\<FormType\<U\>\> \| FormDefinitionArray\<RxapFormControl\<U, any, any\>\> \| RxapFormArray\<U, any, any\> \| RxapFormControl\<any\[any\], any, any\> : T\[K\] extends Record\<string, any\> ? Partial\<FormDefinition\<any\[any\], any, any\>\> & \{ \[K in string \| number \| symbol\]: any\[any\]\[K\] extends U\[\] ? FormDefinitionArray\<(...)\> \| FormDefinitionArray\<(...)\> \| RxapFormArray\<(...), (...), (...)\> \| RxapFormControl\<(...), (...), (...)\> : (...)\[(...)\] extends Record\<(...), (...)\> ? (...) \| (...) : RxapFormControl\<(...), (...), (...)\> \} & Partial\<FormDefinition\<any\[any\], any, any\>\> \| RxapFormControl\<any\[any\], any, any\> : RxapFormControl\<NonEmpty\<T\[K\]\>, any, any\> \} & [`FormDefinition`](../wiki/Interface.FormDefinition)\<`T`, `any`, `any`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:56](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L56)

**`Internal`**

##### Returns

`undefined` \| `Partial`\<[`FormDefinition`](../wiki/Interface.FormDefinition)\<`T`, `any`, `any`\>\> & \{ \[K in string \| number \| symbol\]: T\[K\] extends U\[\] ? FormDefinitionArray\<FormType\<U\>\> \| FormDefinitionArray\<RxapFormControl\<U, any, any\>\> \| RxapFormArray\<U, any, any\> \| RxapFormControl\<any\[any\], any, any\> : T\[K\] extends Record\<string, any\> ? Partial\<FormDefinition\<any\[any\], any, any\>\> & \{ \[K in string \| number \| symbol\]: any\[any\]\[K\] extends U\[\] ? FormDefinitionArray\<(...)\> \| FormDefinitionArray\<(...)\> \| RxapFormArray\<(...), (...), (...)\> \| RxapFormControl\<(...), (...), (...)\> : (...)\[(...)\] extends Record\<(...), (...)\> ? (...) \| (...) : RxapFormControl\<(...), (...), (...)\> \} & Partial\<FormDefinition\<any\[any\], any, any\>\> \| RxapFormControl\<any\[any\], any, any\> : RxapFormControl\<NonEmpty\<T\[K\]\>, any, any\> \} & [`FormDefinition`](../wiki/Interface.FormDefinition)\<`T`, `any`, `any`\>

***

### touched

#### Get Signature

> **get** **touched**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2256

True if the control is marked as `touched`.

A control is marked `touched` once the user has triggered
a `blur` event on it.

##### Returns

`boolean`

#### Set Signature

> **set** **touched**(`value`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2257

##### Parameters

###### value

`boolean`

##### Returns

`void`

#### Inherited from

`UntypedFormGroup.touched`

***

### untouched

#### Get Signature

> **get** **untouched**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2265

True if the control has not been marked as touched

A control is `untouched` if the user has not yet triggered
a `blur` event on it.

##### Returns

`boolean`

#### Inherited from

`UntypedFormGroup.untouched`

***

### updateOn

#### Get Signature

> **get** **updateOn**(): `FormHooks`

Defined in: node\_modules/@angular/forms/index.d.ts:2305

Reports the update strategy of the `AbstractControl` (meaning
the event on which the control updates itself).
Possible values: `'change'` | `'blur'` | `'submit'`
Default value: `'change'`

##### Returns

`FormHooks`

#### Inherited from

`UntypedFormGroup.updateOn`

***

### valid

#### Get Signature

> **get** **valid**(): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2186

A control is `valid` when its `status` is `VALID`.

##### See

[AbstractControl.status](../wiki/Interface.AbstractControl#status)

##### Returns

`boolean`

True if the control has passed all of its validation tests,
false otherwise.

#### Inherited from

`UntypedFormGroup.valid`

***

### validator

#### Get Signature

> **get** **validator**(): `null` \| `ValidatorFn`

Defined in: node\_modules/@angular/forms/index.d.ts:2154

Returns the function that is used to determine the validity of this control synchronously.
If multiple validators have been added, this will be a single composed function.
See `Validators.compose()` for additional information.

##### Returns

`null` \| `ValidatorFn`

#### Set Signature

> **set** **validator**(`validatorFn`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2155

##### Parameters

###### validatorFn

`null` | `ValidatorFn`

##### Returns

`void`

#### Inherited from

`UntypedFormGroup.validator`

## Methods

### addAsyncValidators()

> **addAsyncValidators**(`validators`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2352

Add an asynchronous validator or validators to this control, without affecting other
validators.

When you add or remove a validator at run time, you must call
`updateValueAndValidity()` for the new validation to take effect.

Adding a validator that already exists will have no effect.

#### Parameters

##### validators

The new asynchronous validator function or functions to add to this control.

`AsyncValidatorFn` | `AsyncValidatorFn`[]

#### Returns

`void`

#### Inherited from

`UntypedFormGroup.addAsyncValidators`

***

### addControl()

> **addControl**\<`K`\>(`name`, `control`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:184](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L184)

Add a control to this group. In a strongly-typed group, the control must be in the group's type
(possibly as an optional key).

If a control with a given name already exists, it would *not* be replaced with a new one.
If you want to replace an existing control, use the FormGroup#setControl setControl
method instead. This method also updates the value and validity of the control.

#### Type Parameters

• **K** *extends* `string`

#### Parameters

##### name

`K`

The control name to add to the collection

##### control

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`K`\]\>

Provides the control for the given name

#### Returns

`void`

#### Overrides

`UntypedFormGroup.addControl`

***

### addValidators()

> **addValidators**(`validators`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2340

Add a synchronous validator or validators to this control, without affecting other validators.

When you add or remove a validator at run time, you must call
`updateValueAndValidity()` for the new validation to take effect.

Adding a validator that already exists will have no effect. If duplicate validator functions
are present in the `validators` array, only the first instance would be added to a form
control.

#### Parameters

##### validators

The new validator function or functions to add to this control.

`ValidatorFn` | `ValidatorFn`[]

#### Returns

`void`

#### Inherited from

`UntypedFormGroup.addValidators`

***

### clearAsyncValidators()

> **clearAsyncValidators**(): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2443

Empties out the async validator list.

When you add or remove a validator at run time, you must call
`updateValueAndValidity()` for the new validation to take effect.

#### Returns

`void`

#### Inherited from

`UntypedFormGroup.clearAsyncValidators`

***

### clearValidators()

> **clearValidators**(): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2435

Empties out the synchronous validator list.

When you add or remove a validator at run time, you must call
`updateValueAndValidity()` for the new validation to take effect.

#### Returns

`void`

#### Inherited from

`UntypedFormGroup.clearValidators`

***

### contains()

> **contains**(`controlName`): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:195](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L195)

Check whether there is an enabled control with the given name in the group.

Reports false for disabled controls. If you'd like to check for existence in the group
only, use [get](../wiki/Interface.AbstractControl#get) instead.

#### Parameters

##### controlName

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`T`\>

The control name to check for existence in the collection

#### Returns

`boolean`

false for disabled controls, true otherwise.

#### Overrides

`UntypedFormGroup.contains`

***

### disable()

> **disable**(`opts`?): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2580

Disables the control. This means the control is exempt from validation checks and
excluded from the aggregate value of any parent. Its status is `DISABLED`.

If the control has children, all children are also disabled.

#### Parameters

##### opts?

Configuration options that determine how the control propagates
changes and emits events after the control is disabled.
* `onlySelf`: When true, mark only this control. When false or not supplied,
marks all direct ancestors. Default is false.
* `emitEvent`: When true or not supplied (the default), the `statusChanges`,
`valueChanges` and `events`
observables emit events with the latest status and value when the control is disabled.
When false, no events are emitted.

###### emitEvent?

`boolean`

###### onlySelf?

`boolean`

#### Returns

`void`

#### See

[AbstractControl.status](../wiki/Interface.AbstractControl#status)

#### Inherited from

`UntypedFormGroup.disable`

***

### disabledWhile()

> **disabledWhile**(`observable`, `options`?): `Subscription`

Defined in: [packages/angular/forms/src/lib/form-group.ts:268](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L268)

#### Parameters

##### observable

`Observable`\<`boolean`\>

##### options?

[`ControlOptions`](../wiki/Interface.ControlOptions)

#### Returns

`Subscription`

***

### enable()

> **enable**(`opts`?): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2602

Enables the control. This means the control is included in validation checks and
the aggregate value of its parent. Its status recalculates based on its value and
its validators.

By default, if the control has children, all children are enabled.

#### Parameters

##### opts?

Configure options that control how the control propagates changes and
emits events when marked as untouched
* `onlySelf`: When true, mark only this control. When false or not supplied,
marks all direct ancestors. Default is false.
* `emitEvent`: When true or not supplied (the default), the `statusChanges`,
`valueChanges` and `events`
observables emit events with the latest status and value when the control is enabled.
When false, no events are emitted.

###### emitEvent?

`boolean`

###### onlySelf?

`boolean`

#### Returns

`void`

#### See

[AbstractControl.status](../wiki/Interface.AbstractControl#status)

#### Inherited from

`UntypedFormGroup.enable`

***

### enabledWhile()

> **enabledWhile**(`observable`, `options`?): `Subscription`

Defined in: [packages/angular/forms/src/lib/form-group.ts:275](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L275)

#### Parameters

##### observable

`Observable`\<`boolean`\>

##### options?

[`ControlOptions`](../wiki/Interface.ControlOptions)

#### Returns

`Subscription`

***

### get()

#### Call Signature

> **get**\<`K1`\>(`path`): [`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`K1`\]\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:145](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L145)

Retrieves a child control given the control's name or path.

This signature for get supports strings and `const` arrays (`.get(['foo', 'bar'] as const)`).

##### Type Parameters

• **K1** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### path

\[`K1`\]

##### Returns

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`K1`\]\>

##### Overrides

`UntypedFormGroup.get`

#### Call Signature

> **get**\<`K1`, `K2`\>(`path`): [`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`K1`\]\[`K2`\]\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:146](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L146)

Retrieves a child control given the control's name or path.

This signature for `get` supports non-const (mutable) arrays. Inferred type
information will not be as robust, so prefer to pass a `readonly` array if possible.

##### Type Parameters

• **K1** *extends* `string` \| `number` \| `symbol`

• **K2** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### path

\[`K1`, `K2`\]

##### Returns

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`K1`\]\[`K2`\]\>

##### Overrides

`UntypedFormGroup.get`

#### Call Signature

> **get**\<`K1`, `K2`, `K3`\>(`path`): [`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`K1`\]\[`K2`\]\[`K3`\]\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:149](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L149)

##### Type Parameters

• **K1** *extends* `string` \| `number` \| `symbol`

• **K2** *extends* `string` \| `number` \| `symbol`

• **K3** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### path

\[`K1`, `K2`, `K3`\]

##### Returns

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`K1`\]\[`K2`\]\[`K3`\]\>

##### Overrides

`UntypedFormGroup.get`

#### Call Signature

> **get**(`path`): [`AbstractControl`](../wiki/Interface.AbstractControl)

Defined in: [packages/angular/forms/src/lib/form-group.ts:154](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L154)

##### Parameters

###### path

`string`

##### Returns

[`AbstractControl`](../wiki/Interface.AbstractControl)

##### Overrides

`UntypedFormGroup.get`

***

### getControl()

#### Call Signature

> **getControl**\<`P1`\>(`prop1`): [`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`P1`\]\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:159](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L159)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### prop1

`P1`

##### Returns

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`P1`\]\>

#### Call Signature

> **getControl**\<`P1`, `P2`\>(`prop1`, `prop2`): [`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`P1`\]\[`P2`\]\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:160](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L160)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### prop1

`P1`

###### prop2

`P2`

##### Returns

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`P1`\]\[`P2`\]\>

#### Call Signature

> **getControl**\<`P1`, `P2`, `P3`\>(`prop1`, `prop2`, `prop3`): [`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`P1`\]\[`P2`\]\[`P3`\]\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:164](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L164)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

• **P3** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### prop1

`P1`

###### prop2

`P2`

###### prop3

`P3`

##### Returns

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`P1`\]\[`P2`\]\[`P3`\]\>

#### Call Signature

> **getControl**\<`P1`, `P2`, `P3`, `P4`\>(`prop1`, `prop2`, `prop3`, `prop4`): [`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`P1`\]\[`P2`\]\[`P3`\]\[`P4`\]\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:169](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L169)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

• **P3** *extends* `string` \| `number` \| `symbol`

• **P4** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### prop1

`P1`

###### prop2

`P2`

###### prop3

`P3`

###### prop4

`P4`

##### Returns

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`P1`\]\[`P2`\]\[`P3`\]\[`P4`\]\>

***

### getError()

#### Call Signature

> **getError**\<`K`, `K1`\>(`errorCode`, `path`?): `null` \| `E`\[`K`\]

Defined in: [packages/angular/forms/src/lib/form-group.ts:376](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L376)

##### Type Parameters

• **K** *extends* `string` \| `number` \| `symbol`

• **K1** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### errorCode

`K`

The code of the error to check

###### path?

\[`K1`\]

A list of control names that designates how to move from the current control
to the control that should be queried for errors.

##### Returns

`null` \| `E`\[`K`\]

error data for that particular error. If the control or error is not present,
null is returned.

##### Description

Reports error data for the control with the given path.

##### Usage Notes

For example, for the following `FormGroup`:

```ts
form = new FormGroup({
  address: new FormGroup({ street: new FormControl() })
});
```

The path to the 'street' control from the root form would be 'address' -> 'street'.

It can be provided to this method in one of two formats:

1. An array of string control names, e.g. `['address', 'street']`
1. A period-delimited list of control names in one string, e.g. `'address.street'`

##### Overrides

`UntypedFormGroup.getError`

#### Call Signature

> **getError**\<`K`, `K1`, `K2`\>(`errorCode`, `path`?): `null` \| `E`\[`K`\]

Defined in: [packages/angular/forms/src/lib/form-group.ts:380](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L380)

##### Type Parameters

• **K** *extends* `string` \| `number` \| `symbol`

• **K1** *extends* `string` \| `number` \| `symbol`

• **K2** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### errorCode

`K`

###### path?

\[`K1`, `K2`\]

##### Returns

`null` \| `E`\[`K`\]

##### Overrides

`UntypedFormGroup.getError`

#### Call Signature

> **getError**\<`K`, `K1`, `K2`, `K3`\>(`errorCode`, `path`?): `null` \| `E`\[`K`\]

Defined in: [packages/angular/forms/src/lib/form-group.ts:385](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L385)

##### Type Parameters

• **K** *extends* `string` \| `number` \| `symbol`

• **K1** *extends* `string` \| `number` \| `symbol`

• **K2** *extends* `string` \| `number` \| `symbol`

• **K3** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### errorCode

`K`

###### path?

\[`K1`, `K2`, `K3`\]

##### Returns

`null` \| `E`\[`K`\]

##### Overrides

`UntypedFormGroup.getError`

#### Call Signature

> **getError**\<`K`\>(`errorCode`, `path`?): `null` \| `E`\[`K`\]

Defined in: [packages/angular/forms/src/lib/form-group.ts:391](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L391)

##### Type Parameters

• **K** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### errorCode

`K`

###### path?

`string`

##### Returns

`null` \| `E`\[`K`\]

##### Overrides

`UntypedFormGroup.getError`

***

### getRawValue()

> **getRawValue**(): `T`

Defined in: [packages/angular/forms/src/lib/form-group.ts:141](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L141)

The aggregate value of the `FormGroup`, including any disabled controls.

Retrieves all values regardless of disabled status.

#### Returns

`T`

#### Overrides

`UntypedFormGroup.getRawValue`

***

### hasAsyncValidator()

> **hasAsyncValidator**(`validator`): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2427

Check whether an asynchronous validator function is present on this control. The provided
validator must be a reference to the exact same function that was provided.

#### Parameters

##### validator

`AsyncValidatorFn`

The asynchronous validator to check for presence. Compared by function
    reference.

#### Returns

`boolean`

Whether the provided asynchronous validator was found on this control.

#### Inherited from

`UntypedFormGroup.hasAsyncValidator`

***

### hasError()

#### Call Signature

> **hasError**\<`K1`\>(`errorCode`, `path`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:354](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L354)

##### Type Parameters

• **K1** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### errorCode

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

The code of the error to check

###### path?

\[`K1`\]

A list of control names that designates how to move from the current control
to the control that should be queried for errors.

##### Returns

`boolean`

whether the given error is present in the control at the given path.

If the control is not present, false is returned.

##### Description

Reports whether the control with the given path has the error specified.

##### Usage Notes

For example, for the following `FormGroup`:

```ts
form = new FormGroup({
  address: new FormGroup({ street: new FormControl() })
});
```

The path to the 'street' control from the root form would be 'address' -> 'street'.

It can be provided to this method in one of two formats:

1. An array of string control names, e.g. `['address', 'street']`
1. A period-delimited list of control names in one string, e.g. `'address.street'`

If no path is given, this method checks for the error on the current control.

##### Overrides

`UntypedFormGroup.hasError`

#### Call Signature

> **hasError**\<`K1`, `K2`\>(`errorCode`, `path`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:358](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L358)

##### Type Parameters

• **K1** *extends* `string` \| `number` \| `symbol`

• **K2** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### errorCode

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### path?

\[`K1`, `K2`\]

##### Returns

`boolean`

##### Overrides

`UntypedFormGroup.hasError`

#### Call Signature

> **hasError**\<`K1`, `K2`, `K3`\>(`errorCode`, `path`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:362](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L362)

##### Type Parameters

• **K1** *extends* `string` \| `number` \| `symbol`

• **K2** *extends* `string` \| `number` \| `symbol`

• **K3** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### errorCode

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### path?

\[`K1`, `K2`, `K3`\]

##### Returns

`boolean`

##### Overrides

`UntypedFormGroup.hasError`

#### Call Signature

> **hasError**(`errorCode`, `path`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:367](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L367)

##### Parameters

###### errorCode

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### path?

`string`

##### Returns

`boolean`

##### Overrides

`UntypedFormGroup.hasError`

***

### hasErrorAndDirty()

#### Call Signature

> **hasErrorAndDirty**\<`P1`\>(`error`, `prop1`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:426](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L426)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### error

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### prop1?

`P1`

##### Returns

`boolean`

#### Call Signature

> **hasErrorAndDirty**\<`P1`, `P2`\>(`error`, `prop1`?, `prop2`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:430](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L430)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### error

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### prop1?

`P1`

###### prop2?

`P2`

##### Returns

`boolean`

#### Call Signature

> **hasErrorAndDirty**\<`P1`, `P2`, `P3`\>(`error`, `prop1`?, `prop2`?, `prop3`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:435](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L435)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

• **P3** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### error

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### prop1?

`P1`

###### prop2?

`P2`

###### prop3?

`P3`

##### Returns

`boolean`

#### Call Signature

> **hasErrorAndDirty**\<`P1`, `P2`, `P3`, `P4`\>(`error`, `prop1`?, `prop2`?, `prop3`?, `prop4`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:440](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L440)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

• **P3** *extends* `string` \| `number` \| `symbol`

• **P4** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### error

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### prop1?

`P1`

###### prop2?

`P2`

###### prop3?

`P3`

###### prop4?

`P4`

##### Returns

`boolean`

***

### hasErrorAndTouched()

#### Call Signature

> **hasErrorAndTouched**\<`P1`\>(`error`, `prop1`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:396](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L396)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### error

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### prop1?

`P1`

##### Returns

`boolean`

#### Call Signature

> **hasErrorAndTouched**\<`P1`, `P2`\>(`error`, `prop1`?, `prop2`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:400](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L400)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### error

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### prop1?

`P1`

###### prop2?

`P2`

##### Returns

`boolean`

#### Call Signature

> **hasErrorAndTouched**\<`P1`, `P2`, `P3`\>(`error`, `prop1`?, `prop2`?, `prop3`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:405](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L405)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

• **P3** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### error

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### prop1?

`P1`

###### prop2?

`P2`

###### prop3?

`P3`

##### Returns

`boolean`

#### Call Signature

> **hasErrorAndTouched**\<`P1`, `P2`, `P3`, `P4`\>(`error`, `prop1`?, `prop2`?, `prop3`?, `prop4`?): `boolean`

Defined in: [packages/angular/forms/src/lib/form-group.ts:410](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L410)

##### Type Parameters

• **P1** *extends* `string` \| `number` \| `symbol`

• **P2** *extends* `string` \| `number` \| `symbol`

• **P3** *extends* `string` \| `number` \| `symbol`

• **P4** *extends* `string` \| `number` \| `symbol`

##### Parameters

###### error

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`E`\>

###### prop1?

`P1`

###### prop2?

`P2`

###### prop3?

`P3`

###### prop4?

`P4`

##### Returns

`boolean`

***

### hasValidator()

> **hasValidator**(`validator`): `boolean`

Defined in: node\_modules/@angular/forms/index.d.ts:2418

Check whether a synchronous validator function is present on this control. The provided
validator must be a reference to the exact same function that was provided.

#### Parameters

##### validator

`ValidatorFn`

The validator to check for presence. Compared by function reference.

#### Returns

`boolean`

Whether the provided validator was found on this control.

#### Usage Notes

### Reference to a ValidatorFn

```
// Reference to the RequiredValidator
const ctrl = new FormControl<number | null>(0, Validators.required);
expect(ctrl.hasValidator(Validators.required)).toEqual(true)

// Reference to anonymous function inside MinValidator
const minValidator = Validators.min(3);
const ctrl = new FormControl<number | null>(0, minValidator);
expect(ctrl.hasValidator(minValidator)).toEqual(true)
expect(ctrl.hasValidator(Validators.min(3))).toEqual(false)
```

#### Inherited from

`UntypedFormGroup.hasValidator`

***

### markAllAsDirty()

> **markAllAsDirty**(): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:314](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L314)

#### Returns

`void`

***

### markAllAsPristine()

> **markAllAsPristine**(): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:318](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L318)

#### Returns

`void`

***

### markAllAsTouched()

> **markAllAsTouched**(`opts`?): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2474

Marks the control and all its descendant controls as `touched`.

#### Parameters

##### opts?

Configuration options that determine how the control propagates changes
and emits events after marking is applied.
* `emitEvent`: When true or not supplied (the default), the `events`
observable emits a `TouchedChangeEvent` with the `touched` property being `true`.
When false, no events are emitted.

###### emitEvent?

`boolean`

#### Returns

`void`

#### See

[()](../wiki/Class.RxapFormGroup#markastouched)

#### Inherited from

`UntypedFormGroup.markAllAsTouched`

***

### markAllAsUntouched()

> **markAllAsUntouched**(): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:322](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L322)

#### Returns

`void`

***

### markAsDirty()

> **markAsDirty**(`opts`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:309](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L309)

Marks the control as `dirty`. A control becomes dirty when
the control's value is changed through the UI; compare `markAsTouched`.

#### Parameters

##### opts?

[`OnlySelf`](../wiki/TypeAlias.OnlySelf)

Configuration options that determine how the control propagates changes
and emits events after marking is applied.
* `onlySelf`: When true, mark only this control. When false or not supplied,
marks all direct ancestors. Default is false.
* `emitEvent`: When true or not supplied (the default), the `events`
observable emits a `PristineChangeEvent` with the `pristine` property being `false`.
When false, no events are emitted.

#### Returns

`void`

#### See

 - [()](../wiki/Class.RxapFormGroup#markastouched)
 - [()](../wiki/Class.RxapFormGroup#markasuntouched)
 - [()](../wiki/Class.RxapFormGroup#markaspristine)

#### Overrides

`UntypedFormGroup.markAsDirty`

***

### markAsPending()

> **markAsPending**(`opts`?): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2559

Marks the control as `pending`.

A control is pending while the control performs async validation.

#### Parameters

##### opts?

Configuration options that determine how the control propagates changes and
emits events after marking is applied.
* `onlySelf`: When true, mark only this control. When false or not supplied,
marks all direct ancestors. Default is false.
* `emitEvent`: When true or not supplied (the default), the `statusChanges`
observable emits an event with the latest status the control is marked pending
and the `events` observable emits a `StatusChangeEvent` with the `status` property being
`PENDING` When false, no events are emitted.

###### emitEvent?

`boolean`

###### onlySelf?

`boolean`

#### Returns

`void`

#### See

[AbstractControl.status](../wiki/Interface.AbstractControl#status)

#### Inherited from

`UntypedFormGroup.markAsPending`

***

### markAsPristine()

> **markAsPristine**(`opts`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:304](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L304)

Marks the control as `pristine`.

If the control has any children, marks all children as `pristine`,
and recalculates the `pristine` status of all parent
controls.

#### Parameters

##### opts?

[`OnlySelf`](../wiki/TypeAlias.OnlySelf)

Configuration options that determine how the control emits events after
marking is applied.
* `onlySelf`: When true, mark only this control. When false or not supplied,
marks all direct ancestors. Default is false.
* `emitEvent`: When true or not supplied (the default), the `events`
observable emits a `PristineChangeEvent` with the `pristine` property being `true`.
When false, no events are emitted.

#### Returns

`void`

#### See

 - [()](../wiki/Class.RxapFormGroup#markastouched)
 - [()](../wiki/Class.RxapFormGroup#markasuntouched)
 - [()](../wiki/Class.RxapFormGroup#markasdirty)

#### Overrides

`UntypedFormGroup.markAsPristine`

***

### markAsTouched()

> **markAsTouched**(`opts`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:294](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L294)

Marks the control as `touched`. A control is touched by focus and
blur events that do not change the value.

#### Parameters

##### opts?

[`OnlySelf`](../wiki/TypeAlias.OnlySelf)

Configuration options that determine how the control propagates changes
and emits events after marking is applied.
* `onlySelf`: When true, mark only this control. When false or not supplied,
marks all direct ancestors. Default is false.
* `emitEvent`: When true or not supplied (the default), the `events`
observable emits a `TouchedChangeEvent` with the `touched` property being `true`.
When false, no events are emitted.

#### Returns

`void`

#### See

 - [()](../wiki/Class.RxapFormGroup#markasuntouched)
 - [()](../wiki/Class.RxapFormGroup#markasdirty)
 - [()](../wiki/Class.RxapFormGroup#markaspristine)

#### Overrides

`UntypedFormGroup.markAsTouched`

***

### markAsUntouched()

> **markAsUntouched**(`opts`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:299](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L299)

Marks the control as `untouched`.

If the control has any children, also marks all children as `untouched`
and recalculates the `touched` status of all parent controls.

#### Parameters

##### opts?

[`OnlySelf`](../wiki/TypeAlias.OnlySelf)

Configuration options that determine how the control propagates changes
and emits events after the marking is applied.
* `onlySelf`: When true, mark only this control. When false or not supplied,
marks all direct ancestors. Default is false.
* `emitEvent`: When true or not supplied (the default), the `events`
observable emits a `TouchedChangeEvent` with the `touched` property being `false`.
When false, no events are emitted.

#### Returns

`void`

#### See

 - [()](../wiki/Class.RxapFormGroup#markastouched)
 - [()](../wiki/Class.RxapFormGroup#markasdirty)
 - [()](../wiki/Class.RxapFormGroup#markaspristine)

#### Overrides

`UntypedFormGroup.markAsUntouched`

***

### mergeAsyncValidators()

> **mergeAsyncValidators**(`validators`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:286](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L286)

#### Parameters

##### validators

[`AsyncValidator`](../wiki/TypeAlias.AsyncValidator)

#### Returns

`void`

***

### mergeValidators()

> **mergeValidators**(`validators`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:282](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L282)

#### Parameters

##### validators

[`Validator`](../wiki/TypeAlias.Validator)

#### Returns

`void`

***

### patchValue()

#### Call Signature

> **patchValue**(`valueOrObservable`, `options`?): `Subscription`

Defined in: [packages/angular/forms/src/lib/form-group.ts:246](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L246)

Patches the value of the `FormGroup`. It accepts an object with control
names as keys, and does its best to match the values to the correct controls
in the group.

It accepts both super-sets and sub-sets of the group without throwing an error.

##### Parameters

###### valueOrObservable

`Observable`\<`Partial`\<`T`\>\>

###### options?

[`ControlEventOptions`](../wiki/TypeAlias.ControlEventOptions)

Configuration options that determine how the control propagates changes and
emits events after the value is patched.
* `onlySelf`: When true, each change only affects this control and not its parent. Default is
true.
* `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
`valueChanges` observables emit events with the latest status and value when the control value
is updated. When false, no events are emitted. The configuration options are passed to
the [updateValueAndValidity](../wiki/Interface.AbstractControl#updatevalueandvalidity) method.

##### Returns

`Subscription`

##### Usage Notes

### Patch the value for a form group

```ts
const form = new FormGroup({
   first: new FormControl(),
   last: new FormControl()
});
console.log(form.value);   // {first: null, last: null}

form.patchValue({first: 'Nancy'});
console.log(form.value);   // {first: 'Nancy', last: null}
```

##### Overrides

`UntypedFormGroup.patchValue`

#### Call Signature

> **patchValue**(`valueOrObservable`, `options`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:250](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L250)

##### Parameters

###### valueOrObservable

`Partial`\<`T`\>

###### options?

[`ControlEventOptions`](../wiki/TypeAlias.ControlEventOptions)

##### Returns

`void`

##### Overrides

`UntypedFormGroup.patchValue`

***

### registerControl()

#### Call Signature

> **registerControl**\<`K`\>(`name`, `control`): `any`

Defined in: node\_modules/@angular/forms/index.d.ts:1529

Registers a control with the group's list of controls. In a strongly-typed group, the control
must be in the group's type (possibly as an optional key).

This method does not update the value or validity of the control.
Use FormGroup#addControl addControl instead.

##### Type Parameters

• **K** *extends* `string`

##### Parameters

###### name

`K`

The control name to register in the collection

###### control

`any`

Provides the control for the given name

##### Returns

`any`

##### Inherited from

`UntypedFormGroup.registerControl`

#### Call Signature

> **registerControl**(`this`, `name`, `control`): `AbstractControl`\<`any`\>

Defined in: node\_modules/@angular/forms/index.d.ts:1530

Registers a control with the group's list of controls. In a strongly-typed group, the control
must be in the group's type (possibly as an optional key).

This method does not update the value or validity of the control.
Use FormGroup#addControl addControl instead.

##### Parameters

###### this

`FormGroup`\<\{\}\>

###### name

`string`

The control name to register in the collection

###### control

`AbstractControl`\<`any`\>

Provides the control for the given name

##### Returns

`AbstractControl`\<`any`\>

##### Inherited from

`UntypedFormGroup.registerControl`

***

### removeAsyncValidators()

> **removeAsyncValidators**(`validators`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2394

Remove an asynchronous validator from this control, without affecting other validators.
Validators are compared by function reference; you must pass a reference to the exact same
validator function as the one that was originally set. If a provided validator is not found, it
is ignored.

When you add or remove a validator at run time, you must call
`updateValueAndValidity()` for the new validation to take effect.

#### Parameters

##### validators

The asynchronous validator or validators to remove.

`AsyncValidatorFn` | `AsyncValidatorFn`[]

#### Returns

`void`

#### Inherited from

`UntypedFormGroup.removeAsyncValidators`

***

### removeControl()

> **removeControl**(`name`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:191](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L191)

#### Parameters

##### name

[`ExtractStrings`](../wiki/TypeAlias.ExtractStrings)\<`T`\>

#### Returns

`void`

#### Overrides

`UntypedFormGroup.removeControl`

***

### removeValidators()

> **removeValidators**(`validators`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2382

Remove a synchronous validator from this control, without affecting other validators.
Validators are compared by function reference; you must pass a reference to the exact same
validator function as the one that was originally set. If a provided validator is not found,
it is ignored.

#### Parameters

##### validators

The validator or validators to remove.

`ValidatorFn` | `ValidatorFn`[]

#### Returns

`void`

#### Usage Notes

### Reference to a ValidatorFn

```
// Reference to the RequiredValidator
const ctrl = new FormControl<string | null>('', Validators.required);
ctrl.removeValidators(Validators.required);

// Reference to anonymous function inside MinValidator
const minValidator = Validators.min(3);
const ctrl = new FormControl<string | null>('', minValidator);
expect(ctrl.hasValidator(minValidator)).toEqual(true)
expect(ctrl.hasValidator(Validators.min(3))).toEqual(false)

ctrl.removeValidators(minValidator);
```

When you add or remove a validator at run time, you must call
`updateValueAndValidity()` for the new validation to take effect.

#### Inherited from

`UntypedFormGroup.removeValidators`

***

### reset()

> **reset**(`formState`?, `options`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:326](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L326)

Resets the `FormGroup`, marks all descendants `pristine` and `untouched` and sets
the value of all descendants to their default values, or null if no defaults were provided.

You reset to a specific form state by passing in a map of states
that matches the structure of your form, with control names as keys. The state
is a standalone value or a form state object with both a value and a disabled
status.

#### Parameters

##### formState?

`Partial`\<`T`\>

##### options?

[`ControlEventOptions`](../wiki/TypeAlias.ControlEventOptions)

Configuration options that determine how the control propagates changes
and emits events when the group is reset.
* `onlySelf`: When true, each change only affects this control, and not its parent. Default is
false.
* `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
`valueChanges`
observables emit events with the latest status and value when the control is reset.
When false, no events are emitted.
The configuration options are passed to the [updateValueAndValidity](../wiki/Interface.AbstractControl#updatevalueandvalidity) method.

#### Returns

`void`

#### Usage Notes

### Reset the form group values

```ts
const form = new FormGroup({
  first: new FormControl('first name'),
  last: new FormControl('last name')
});

console.log(form.value);  // {first: 'first name', last: 'last name'}

form.reset({ first: 'name', last: 'last name' });

console.log(form.value);  // {first: 'name', last: 'last name'}
```

### Reset the form group values and disabled status

```ts
const form = new FormGroup({
  first: new FormControl('first name'),
  last: new FormControl('last name')
});

form.reset({
  first: {value: 'name', disabled: true},
  last: 'last'
});

console.log(form.value);  // {last: 'last'}
console.log(form.get('first').status);  // 'DISABLED'
```

#### Overrides

`UntypedFormGroup.reset`

***

### select()

> **select**\<`R`\>(`mapFn`): `Observable`\<`R`\>

Defined in: [packages/angular/forms/src/lib/form-group.ts:137](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L137)

#### Type Parameters

• **R**

#### Parameters

##### mapFn

(`state`) => `R`

#### Returns

`Observable`\<`R`\>

***

### setAsyncValidators()

> **setAsyncValidators**(`newValidator`, `updateValueAndValidity`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:340](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L340)

Sets the asynchronous validators that are active on this control. Calling this
overwrites any existing asynchronous validators.

When you add or remove a validator at run time, you must call
`updateValueAndValidity()` for the new validation to take effect.

If you want to add a new validator without affecting existing ones, consider
using `addAsyncValidators()` method instead.

#### Parameters

##### newValidator

[`AsyncValidator`](../wiki/TypeAlias.AsyncValidator)

##### updateValueAndValidity

`boolean` = `true`

#### Returns

`void`

#### Overrides

`UntypedFormGroup.setAsyncValidators`

***

### setControl()

> **setControl**\<`K`\>(`name`, `control`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:199](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L199)

Replace an existing control. In a strongly-typed group, the control must be in the group's type
(possibly as an optional key).

If a control with a given name does not exist in this `FormGroup`, it will be added.

#### Type Parameters

• **K** *extends* `string`

#### Parameters

##### name

`K`

The control name to replace in the collection

##### control

[`AbstractControl`](../wiki/Interface.AbstractControl)\<`T`\[`K`\]\>

Provides the control for the given name

#### Returns

`void`

#### Overrides

`UntypedFormGroup.setControl`

***

### setDisable()

> **setDisable**(`disable`, `opts`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:460](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L460)

#### Parameters

##### disable

`boolean` = `true`

##### opts?

[`ControlEventOptions`](../wiki/TypeAlias.ControlEventOptions)

#### Returns

`void`

***

### setEnable()

> **setEnable**(`enable`, `opts`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:456](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L456)

#### Parameters

##### enable

`boolean` = `true`

##### opts?

[`ControlEventOptions`](../wiki/TypeAlias.ControlEventOptions)

#### Returns

`void`

***

### setErrors()

> **setErrors**(`errors`, `opts`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:372](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L372)

Sets errors on a form control when running validations manually, rather than automatically.

Calling `setErrors` also updates the validity of the parent control.

#### Parameters

##### errors

`null` | `Partial`\<`E`\>

##### opts

[`EmitEvent`](../wiki/TypeAlias.EmitEvent) = `{}`

Configuration options that determine how the control propagates
changes and emits events after the control errors are set.
* `emitEvent`: When true or not supplied (the default), the `statusChanges`
observable emits an event after the errors are set.

#### Returns

`void`

#### Usage Notes

### Manually set the errors for a control

```ts
const login = new FormControl('someLogin');
login.setErrors({
  notUnique: true
});

expect(login.valid).toEqual(false);
expect(login.errors).toEqual({ notUnique: true });

login.setValue('someOtherLogin');

expect(login.valid).toEqual(true);
```

#### Overrides

`UntypedFormGroup.setErrors`

***

### setParent()

> **setParent**(`parent`): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2612

Sets the parent of the control

#### Parameters

##### parent

The new parent.

`null` | `FormGroup`\<`any`\> | `FormArray`\<`any`\>

#### Returns

`void`

#### Inherited from

`UntypedFormGroup.setParent`

***

### setValidators()

> **setValidators**(`newValidator`, `updateValueAndValidity`): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:330](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L330)

Sets the synchronous validators that are active on this control.  Calling
this overwrites any existing synchronous validators.

When you add or remove a validator at run time, you must call
`updateValueAndValidity()` for the new validation to take effect.

If you want to add a new validator without affecting existing ones, consider
using `addValidators()` method instead.

#### Parameters

##### newValidator

[`Validator`](../wiki/TypeAlias.Validator)

##### updateValueAndValidity

`boolean` = `true`

#### Returns

`void`

#### Overrides

`UntypedFormGroup.setValidators`

***

### setValue()

#### Call Signature

> **setValue**(`valueOrObservable`, `options`?): `Subscription`

Defined in: [packages/angular/forms/src/lib/form-group.ts:206](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L206)

Sets the value of the `FormGroup`. It accepts an object that matches
the structure of the group, with control names as keys.

##### Parameters

###### valueOrObservable

`Observable`\<`T`\>

###### options?

[`ControlEventOptions`](../wiki/TypeAlias.ControlEventOptions)

Configuration options that determine how the control propagates changes
and emits events after the value changes.
The configuration options are passed to the [updateValueAndValidity](../wiki/Interface.AbstractControl#updatevalueandvalidity) method.

* `onlySelf`: When true, each change only affects this control, and not its parent. Default is
false.
* `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
`valueChanges`
observables emit events with the latest status and value when the control value is updated.
When false, no events are emitted.

##### Returns

`Subscription`

##### Usage Notes

### Set the complete value for the form group

```ts
const form = new FormGroup({
  first: new FormControl(),
  last: new FormControl()
});

console.log(form.value);   // {first: null, last: null}

form.setValue({first: 'Nancy', last: 'Drew'});
console.log(form.value);   // {first: 'Nancy', last: 'Drew'}
```

##### Throws

When strict checks fail, such as setting the value of a control
that doesn't exist or if you exclude a value of a control that does exist.

##### Overrides

`UntypedFormGroup.setValue`

#### Call Signature

> **setValue**(`valueOrObservable`, `options`?): `void`

Defined in: [packages/angular/forms/src/lib/form-group.ts:210](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L210)

##### Parameters

###### valueOrObservable

`T`

###### options?

[`ControlEventOptions`](../wiki/TypeAlias.ControlEventOptions)

##### Returns

`void`

##### Overrides

`UntypedFormGroup.setValue`

***

### updateValueAndValidity()

> **updateValueAndValidity**(`opts`?): `void`

Defined in: node\_modules/@angular/forms/index.d.ts:2644

Recalculates the value and validation status of the control.

By default, it also updates the value and validity of its ancestors.

#### Parameters

##### opts?

Configuration options determine how the control propagates changes and emits events
after updates and validity checks are applied.
* `onlySelf`: When true, only update this control. When false or not supplied,
update all direct ancestors. Default is false.
* `emitEvent`: When true or not supplied (the default), the `statusChanges`,
`valueChanges` and `events`
observables emit events with the latest status and value when the control is updated.
When false, no events are emitted.

###### emitEvent?

`boolean`

###### onlySelf?

`boolean`

#### Returns

`void`

#### Inherited from

`UntypedFormGroup.updateValueAndValidity`

***

### validateOn()

> **validateOn**(`observableValidation`): `Subscription`

Defined in: [packages/angular/forms/src/lib/form-group.ts:350](https://gitlab.com/rxap/packages/-/blob/36b0e9732b24717840935712e316593ff6aba795/packages/angular/forms/src/lib/form-group.ts#L350)

#### Parameters

##### observableValidation

`Observable`\<`null` \| `object`\>

#### Returns

`Subscription`
